<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Http\Requests\StoreFileRequest;
use App\Http\Requests\UpdateFileRequest;
use App\Models\File;
use App\Jobs\ProcessFiles;
use Illuminate\Http\Request;
use Illuminate\Http\Resources\Json\JsonResource;
use Spatie\RouteAttributes\Attributes\Resource;
use Spatie\RouteAttributes\Attributes\Post;

#[Resource(
    resource: 'files',
    apiResource: true,
    only: ['index']
)]
class FileController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        return JsonResource::collection(File::paginate(request()->input('limit', 20)));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(StoreFileRequest $request)
    {
        //
    }

    /**
     * Display the specified resource.
     */
    public function show(File $file)
    {
        //
    }



    /**
     * Update the specified resource in storage.
     */
    public function update(UpdateFileRequest $request, File $file)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(File $file)
    {
        //
    }

    #[Post('files/upload', 'files.upload')]
    public function uploader(Request $request)
    {

        $request->validate([
            'files.*' => 'required|file|mimes:txt|max:8192',
        ]);

        $files = [];
        foreach ((array) $request->file('files') as $uploadedFile) {
            $hash = md5($uploadedFile->getClientOriginalName() . microtime(true));
            $path = sprintf('files/%s/%s/%s.%s', $hash[0] ?: 1, $hash[1] ?: 1, $hash, $uploadedFile->getClientOriginalExtension());

            /*** @var \Illuminate\Http\UploadedFile|\Illuminate\Http\UploadedFile[] $uploadedFile **/
            $file = \App\Models\File::create([
                'name'   => $uploadedFile->getClientOriginalName(),
                'stub'   => $path,
                'size'   => $uploadedFile->getSize(),
                'type'   => $uploadedFile->getMimeType(),
                'disk'   => config('filesystems.cloud')
            ]);

            $uploadedFile->storeAs('/', $path, config('filesystems.cloud'));

            ProcessFiles::dispatch($file);

            $files[] = $file;
        }

        return JsonResource::collection($files);
    }
}
