<?php

namespace App\Jobs;

use App\Models\File;
use App\Services\ParseFile;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldBeUnique;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\Middleware\WithoutOverlapping;
use Illuminate\Queue\SerializesModels;
use Throwable;

class ProcessFiles implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    public $timeout = 86000; // 24 hours

    /**
     * Create a new job instance.
     */
    public function __construct(
        public File $file,
    ) {
    }

    /**
     * Execute the job.
     */
    public function handle(ParseFile $parseFileService): void
    {
        $parseFileService->process($this->file);
    }

    /**
     * Handle a job failure.
     */
    public function failed(Throwable $exception): void
    {
        // Send user notification of failure, etc...
    }

    // public function middleware()
    // {
    //     return [(new WithoutOverlapping('files'))->releaseAfter(60)->expireAfter(180)->shared()];
    // }
}
