<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;

class Channel extends Model
{
    use HasFactory;

    public $guarded = ['id'];

    public $incrementing = false;
    
    /**
     * The users that belong to the role.
     */
    public function stations(): BelongsToMany
    {
        return $this->belongsToMany(Station::class, 'station_channel')
            ->using(StationChannel::class)
            ->withPivot('properties');
    }
}
