<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;

class Station extends Model
{
    use HasFactory;

    public $guarded = ['id'];

    public $timestamps = false;

    /**
     * The users that belong to the role.
     */
    public function channels(): BelongsToMany
    {
        return $this->belongsToMany(Channel::class, 'station_channel')
            ->using(StationChannel::class)
            ->withPivot('properties');
    }

}
