<?php

namespace App\Models;

use Carbon\CarbonInterface;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;

class WeatherData extends Model
{
    use HasFactory;

    public $table = "weatherdata2";

    public $timestamps = false;

    public $guarded = ['id'];


    public $dates = [
        'software_channel_datetime'
    ];
    /**
     * The users that belong to the role.
     */
    public function station(): BelongsTo
    {
        return $this->belongsTo(Station::class, 'software_channel_sn', 'sn');
            // ->using(StationChannel::class)
            // ->withPivot('properties');
    }


    public static function getDN(CarbonInterface $dt)
    {
        $year = $dt->year;
        $month = $dt->month;
        $day = $dt->day;
        $hour = $dt->hour;
        $min = $dt->minute;

        if (($year % 4 == 0 && $year % 100 != 0) || $year % 400 == 0)
            $M = [0, 0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335];
        else
            $M = [0, 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334];

        $dn = ((($min / 60) + $hour) / 24) + $day + $M[$month];

        return $dn;
    }
    
}
