<?php

namespace App\Providers;

use App\Jobs\ProcessFiles;
use App\Services\ParseFile;
use Illuminate\Support\ServiceProvider;
use Laravel\Sanctum\Sanctum;
use Illuminate\Contracts\Foundation\Application;

class AppServiceProvider extends ServiceProvider
{
    /**
     * Register any application services.
     */
    public function register(): void
    {
        // Sanctum::ignoreMigrations();
    }

    /**
     * Bootstrap any application services.
     */
    public function boot(): void
    {

        $this->app->bindMethod([ProcessFiles::class, 'handle'], function (ProcessFiles $job, Application $app) {
            return $job->handle($app->make(ParseFile::class));
        });

        // Sanctum::usePersonalAccessTokenModel(PersonalAccessToken::class);
    }
}
