
import '../css/app.scss'

import { createApp } from 'vue'
import { createPinia } from 'pinia'
import { Quasar, ClosePopup, Dialog, Notify} from "quasar";

import Router from '@/router'
import App from './App.vue'

const app = createApp(App)
const Store = createPinia()

app.use(Router)
Store.use(({ store }) => { store.router = markRaw(Router) });
app.use(Store)
app.use(Quasar, {
    plugins: [ Dialog, Notify ],
    directives : [ ClosePopup ],
    config : {
        notify :{
            position: 'top-right',
            timeout: 2500,
            color: 'secondary',
            classes: 'my-notify-class',
            icon: 'done',
            // closeBtn : 'X'
        }
        // loadingBar: { skipHijack: true }
    },
  })

app.mount('#app')