import http from "@/plugins/axios.js";

export const useTable = (url) => {
    const loading = ref(false);
    const rows = ref([]);
    
    const filter = () => {
        loading.value = true

        http.get(url, { params: unref(search) }).then(({ data }) => {
            rows.value = data.data;
            pagination.value = {
                ...unref(pagination),
                rowsNumber: parseInt(data.meta.total),
                page: parseInt(data.meta.current_page),
                rowsPerPage: parseInt(data.meta.per_page),
            };
        }).finally(() => {
            loading.value = false
        })
    };

    const save = async (data) => {
        loading.value = true
        const body =  { ...unref(data) }
        // if(body?.id) 
        await http({
            method : body?.id ? 'PUT' : 'POST',
            url : body?.id ? `${url}/${body?.id}` : url,
            data : body
        }).then(({ data }) => {
            return data
        }).finally(() => {
            loading.value = false
        })
    }
    
    const search = ref({
        query: "",
    });
    
    const pagination = ref({
        sortBy: "id",
        descending: true,
        page: 1,
        rowsPerPage: 20,
        rowsNumber: 0,
    });

    onMounted(() => {
        filter();
    });

    return {
        rows, search, pagination, loading, filter, save
    }
    
}