import axios from "axios";
import { Notify } from "quasar";

export const baseURL = '/api/';

const errorResponse = (response, msg = "") => {
    const { data } = response || {};

    Notify.create({
        type: "negative",
        color: "red-5",
        message: data?.message || msg || data?.data?.map((e) => e.msg).join(", ") || "An Error Occured!!",
    });

    return Promise.reject(response?.data);
};

const http = axios.create({
    baseURL,
    headers: {
        "X-Requested-With": "XMLHttpRequest"
    },
});

http.defaults.withCredentials = true;


http.interceptors.request.use((request) => {
    // const locale = store.getters["lang/locale"];
    // if (locale) request.headers.common["Accept-Language"] = locale;
    // request.headers.common["X-CSRF-TOKEN"] = store.getters["auth/csrf"]; //window.config.csrfToken;
    // request.headers.common["X-Requested-With"] = "XMLHttpRequest";
    // request.headers['X-Socket-Id'] = Echo.socketId()

    // request.params['HTTP_MODAUTH'] = store?.state?.user?.HTTP_MODAUTH || 'api',
    // request.headers.common["Authorization"] =
    //     "Bearer " + store.getters["user/token"];

    return request;
});


http.interceptors.response.use(
    (response) => {
        if (response?.data?.success === false) {
            return errorResponse(response);
        }
        return Promise.resolve(response);
    },
    (error) => {
        return errorResponse(error.response, error?.message);
    }
);

export default http;