import { defineConfig } from 'vite';
import laravel from 'laravel-vite-plugin';
import vue from '@vitejs/plugin-vue';
import { quasar, transformAssetUrls } from '@quasar/vite-plugin'
import AutoImport from 'unplugin-auto-import/vite'

export default defineConfig({
    plugins: [
        AutoImport({ 
            dirs: [
                "resources/js/composables",
                "resources/js/store",
            ],
            imports: [
                // presets
                'vue',
                'vue-router',
            ]
         }),
        laravel({
            input: ['resources/js/app.js'],
            // refresh: true,
        }),
        vue({
            template: { transformAssetUrls }
            // template: {
            //     transformAssetUrls: {
            //         // The Vue plugin will re-write asset URLs, when referenced
            //         // in Single File Components, to point to the Laravel web
            //         // server. Setting this to `null` allows the Laravel plugin
            //         // to instead re-write asset URLs to point to the Vite
            //         // server instead.
            //         base: null,
 
            //         // The Vue plugin will parse absolute URLs and treat them
            //         // as absolute paths to files on disk. Setting this to
            //         // `false` will leave absolute URLs un-touched so they can
            //         // reference assets in the public directory as expected.
            //         includeAbsolute: false,
            //     },
            // },
        }),
        quasar({
            sassVariables: 'resources/css/quasar-variables.sass'
        })
    ],
    resolve: {
        alias: {
            '@': '/resources/js',
        }
    },
});
